<template>
  <div>
    <header class="header-area">
      <h1>
        <div class="nth-line-2">Livre d'or</div>
      </h1>
    </header>
    <!--La directive v-for permet de récup les éléments
    de l'objet data. Message représente la propriété de 
    l'objet en cours d'itération.
    Un attribut unique key a été fourni pour chaque 
    propriété de l'objet source de manière à ce qu'il 
    puisse ê réutilisé-->    
    <div class="profile--2"></div>
    <div class="wrapper">
      <div v-for="message in data" :key="message.id"
       class="speechbubble">
        <p>
          {{ message.message }}
        </p>
          <p class="username">{{ message.Auteur.email }}</p>
      </div>
    </div>
     <!-- Liaison de données bidirectionnelle via la directive
     v-model qui choisit automatiquement la bonne manière de
     mettre à jour l'élément en fonction du type de champ -->
    <div id="container--ck">
    <label class="ui-form-input-container">
      <textarea class="custom--editor"
       type="text"
       rows="12"
       cols="71"
       placeholder="Votre message"
       v-model="message">
       </textarea>
       <span class="form-input-label">
       Message</span>
    </label>

    <label class="ui-form-input-container">
       <input       
       type="text"
       v-model="email"
       placeholder="Votre e-mail"
       class="custom--input"
       value="">
       <span class="form-input-label">
       E-mail</span>
    </label>       
       <!-- Gestion de l'évènement click: l'instruction v-on
       @click en raccourci a été utilisée dans le but d'éxécuter
       du JS lorsqu'un utilsiateur poste un message en cliquant
       sur le bouton Signer -->
      <div class="btn--container">
        <button class="btn--starfleet" @click="postMessage">
          <img src="../assets/pencil.png" />
          Signer
        </button>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "livreDor",
  metaInfo: {
      title: 'Livre dor Leonard Nimoy'
    },
   data() {
    return {
       data: {},
       dataFront: {},
       message: '',
       email: '',
       allMessages: [],
      
            
    };
  },
  beforeMount(){
    this.getLivreDor();
    this.getLivreDorFront();
  },
  
  methods: {
    async getLivreDor(){
      const res = await fetch('http://127.0.0.1:8000/api/livredor');
      const data = await res.json();
      this.data = data;
      this.allMessages.push(data);
      console.log (this.allMessages)
    }, 

    async postMessage() {
      const res = await fetch('http://127.0.0.1:8000/api/message', {
          method: "POST",
          body: JSON.stringify({
            email: this.email,
            message: this.message,
          })
        });
      const message = await res.json();
      this.message = message;
    },

    async getLivreDorFront(){
      const res = await fetch('http://127.0.0.1:8000/api/message');
      const data = await res.json();
      this.dataFront = data;
      console.log (this.dataFront);
    }, 


  }
};
</script>

<style>
@import url("https://fonts.googleapis.com/css2?family=Mukta:wght@300&family=Quicksand&display=swap");
@import url(https://fonts.googleapis.com/css?family=Old+Standard+TT:400|Lora:400);

header .header-area {
  text-align: right;
  margin-top: 0;
  padding: 0 1em;
  font-family: "Old Standard TT", serif;
}

h1 {
  margin-top: 0;
  font-family: "Old Standard TT", serif;
  color: #1da2f1;
  text-transform: uppercase;
  font-weight: 400;
}

.nth-line-2 {
  font-size: 14vw;
}
@media (min-width: 55em) {

  header.header-area {
    margin-right: 0;
  }
  .nth-line-2 {
    font-size: 5vw;
    margin-right: 160px;
  }  
}

.profile--2 {
  background: url("../assets/Mr-Spock.jpg") center 20%;
  height: 35vh;
  background-size: cover;
}
@media (min-width: 55em) {
  .profile--2 {
    width: 45%;
    position: fixed;
    top: 0;
    left: 0;
    bottom: 0;
    height: auto;
  }
}
@media (min-width: 80em) {
  .profile--2 {
    width: 45%;
    top: 0;
    left: 0;
    bottom: 0;
    height: auto;
  }
}

.wrapper {
  max-width: 550px;
  margin-left: 700px;
  margin-right: 58px;
}

@media screen and (max-width: 60.75em) {
  .wrapper {
    max-width: 800px;
    margin-top: 40px;
    margin-bottom: 0;
    margin-left: 52px;
    margin-right: 52px;
  }
}

.wrapper .speechbubble {
  background-color: #26272b;
  color: white;
  line-height: 1.75;
  padding-left: 20px;
  padding-right: 20px;
  padding-top: 25px;
  padding-bottom: 70px;
  margin-bottom: 40px;
  cursor: default;
}

@media screen and (max-width: 60.75em) {
  .wrapper .speechbubble {
   margin-bottom: 42px;
  }
}

.wrapper .speechbubble:nth-child(2n) {
  border-left: 5px solid;
}

.wrapper .speechbubble:nth-child(2n + 1) {
  border-right: 5px solid;
}

.wrapper .speechbubble:nth-child(4n + 1) {
  border-color: #1da2f1;
}
.wrapper .speechbubble:nth-child(4n + 2) {
  border-color: #1da2f1;
}
.wrapper .speechbubble:nth-child(4n + 3) {
  border-color: #1da2f1;
}
.wrapper .speechbubble:nth-child(4n + 4) {
  border-color: #1da2f1;
}

.wrapper .speechbubble .username {
  display: inline;
  font-style: italic;
  float: right;
}

#container--ck {
  float: right;
  max-width: 800px;
  margin-right: 96px;
}

#cke_1_top {
  width: 100%;
  padding: 0;
}
.custom--editor,
.custom--input {
  background-color: #191919;
  color: #fff;      
  border: 3px solid #1da2f1;
  border-radius: 5px;
  outline: 0;
  padding: 13px;
  display: flex;  
  justify-content: center;
  font-family: "Mukta", sans-serif;
  font-variant: all-small-caps;
  font-size: 20px;
  transition: .2s;
}
.custom--editor{
  max-width: 520px;
  max-height: 200px;
}
.custom--editor:focus,
.custom--input:focus{
  border-color: #fff;
  transition: .3s;
}
.custom--editor::placeholder,
.custom--input::placeholder{
   font-family: "Mukta", sans-serif;
   font-variant: all-small-caps;
   color: #D3D3D3;
}
.custom--input{
  margin-top: 35px;
  justify-items: self-end;
  max-width: 200px;
}


.ui-form-input-container{
  position: relative;
  font-size: 1rem;
  display: block;  
}
.form-input-label {
  position: absolute;
  top: -12px;
  left: 10px;
  color: #1da2f1;
  padding-right: 0.33rem;
  padding-left: 0.33rem;
  background-color: #191919;
  transition: all 0.15s cubic-bezier(0.4, 0, 0.2, 1);
  font-family: "Mukta", sans-serif;
  font-variant: all-small-caps;
  font-size: 18px;
}
@media screen and (max-width: 60.75em) {
  #container--ck {
    margin: 52px;
  }

  .custom--editor{
    display: flex;  
    justify-content: center;
    max-width: 301px;
  }
  .custom--editor::placeholder{
   font-family: "Mukta", sans-serif;
   font-variant: all-small-caps;
   color: #D3D3D3;
  }
}
@media all and (max-width: 1349px) {
 .wrapper {
   max-width: 650px;
   margin-left: 650px;
   margin-right: 58px;
  }
  
  #container--ck{
    margin-right: 60px;
  }
 .custom--editor,
 .custom--input {
   max-width: 570px;
   max-height: 200px;
 } 
}

@media all and (max-width: 1267px) { 
  .wrapper {
   max-width: 650px;
   margin-left: 590px;
   margin-right: 58px;
  }
  
  #container--ck{
    margin-right: 58px;
  }
 .custom--editor,
 .custom--input {
   max-width: 520px;
   max-height: 200px;
 } 
}

@media all and (max-width: 1182px) {
  .wrapper {
   max-width: 550px;
   margin-left: 550px;
   margin-right: 58px;
  }
  #container--ck{
    margin-right: 53px;
  }
 .custom--editor,
 .custom--input {
   max-width: 500px;
   max-height: 200px;
 }  
}
@media all and (max-width: 1147px) { 
  .wrapper {
   max-width: 550px;
   margin-left: 530px;
   margin-right: 58px;
  }
  #container--ck{
    margin-right: 53px;
  }
 .custom--editor,
 .custom--input {
   max-width: 460px;
   max-height: 200px;
 }  
}
@media all and (max-width: 1017px) {
  .wrapper {
   max-width: 650px;
   margin-left: 420px;
   margin-right: 58px;
  }
  #container--ck{
    margin-right: 53px;
  }
 .custom--editor,
 .custom--input {
   max-width: 400px;
   max-height: 200px;
 } 
}
@media all and (max-width: 909px) {
 .custom--editor,
 .custom--input {
   max-width: 380px;
   max-height: 200px;
 }  
}
@media all and (max-width: 892px) {
  .wrapper {
   max-width: 690px;
   margin-left: 425px;
   margin-right: 65px;
  }
  #container--ck{
    margin-right: 65px;
  }
 .custom--editor,
 .custom--input {
   max-width: 345px;
   max-height: 200px;
 }  
}
@media all and (max-width: 877px) {
  .wrapper {
   max-width: 850px;
   margin-left: 65px;
   margin-right: 65px;
  }
  #container--ck{
    margin-right: 65px;
  }
 .custom--editor,
 .custom--input {
   max-width: 690px;
   max-height: 200px;
 }  
}
@media all and (max-width: 802px) {
 .custom--editor,
 .custom--input {
   max-width: 610px;
   max-height: 200px;
 }  
}
@media all and (max-width: 791px) {
  .wrapper {
   max-width: 650px;
   margin-left: 65px;
   margin-right: 58px;
  }
  #container--ck{
    margin-right: 55px;
  }
 .custom--editor,
 .custom--input {
   max-width: 610px;
   max-height: 200px;
 }  
}
@media all and (max-width: 725px) {
  .wrapper {
   max-width: 680px;
   margin-left: 50px;
   margin-right: 58px;
  }
  #container--ck{
    margin-right: 55px;
  }
 .custom--editor,
 .custom--input {
   max-width: 570px;
   max-height: 200px;
 }  
}

@media all and (max-width: 734px) {
  .custom--editor,
 .custom--input {
   max-width: 560px;
   max-height: 200px;
 }   
}
@media all and (max-width: 704px) {
 .custom--editor,
 .custom--input {
   max-width: 540px;
   max-height: 200px;
 }
}
@media all and (max-width: 657px) {
 .custom--editor,
 .custom--input {
   max-width: 500px;
   max-height: 200px;
 }
}

@media all and (max-width: 560px) {
  .wrapper {
   max-width: 650px;
   margin-left: 60px;
   margin-right: 58px;
  }
  
  #container--ck{
    margin-right: 56px;
  }
 .custom--editor,
 .custom--input {
   max-width: 285px;
   max-height: 200px;
 }
}
.btn--container {
  margin-top: 20px;
}

button.btn--starfleet {
  display: block;
  text-align: center;
  padding-top: 6px;
  margin-bottom: 35px;
  width: 100%;
  font-family: "Mukta", sans-serif;
  font-variant: all-small-caps;
  background-color: #1da2f1;
  color: white;
  font-size: 22px;
  border: 3px solid #1da2f1;
  border-radius: 5px;
  transition: .2s;
}


button.btn--starfleet:hover {
  justify-content: center;
  background-color: #1da2f1;
  border-color: white;
  transition: .3s;
}

.btn--poster {
  width: 100%;
  background: url(../assets/publish.png);
  background-repeat: no-repeat;
}
</style>
